void pio_setup()
{
  // Enable clocks in PMC
  pmc_set_writeprotect(0);
  pmc_enable_periph_clk(ID_PIOC);

  PIOC->PIO_ODR |= PIO_PER_P6; // Disable PIO output
  PIOC->PIO_IFER|= PIO_PER_P6;
//  PIOC->PIO_PUER|= PIO_PER_P6;
  PIOC->PIO_ODR |= PIO_PER_P7; // Disable PIO output
  PIOC->PIO_IFER|= PIO_PER_P7;
//  PIOC->PIO_PUER|= PIO_PER_P7;
  PIOC->PIO_ODR |= PIO_PER_P8; // Disable PIO output
  PIOC->PIO_IFER|= PIO_PER_P8;
//  PIOC->PIO_PUER|= PIO_PER_P8;
  PIOC->PIO_ODR |= PIO_PER_P9; // Disable PIO output
  PIOC->PIO_IFER|= PIO_PER_P9;
//  PIOC->PIO_PUER|= PIO_PER_P9;
}
void adc_setup(bool *pwm_event)
{
 // #define ADC_CLOCK    (16000000)
  //Setup analog read

  // adc_set_writeprotect(ADC,0);
  pmc_enable_periph_clk(ID_ADC);
  ADC->ADC_CR |=1; //reset the adc
  ADC->ADC_MR= 0x10380200; // 0x9038FF00;  //default setting for  ADC_MR register :
    //USEQ = 0;
  //TRANSFER = 1;
  //TRACKTIM = 0;
  //ANACH = 0;
  //SETTLING = 3;
  //STARTUP = 8;
  //PRESCAL = 2;
  //FREERUN = 0;
  //FWUP = 0;
  //SLEEP = 0;
  //LOWRES = 0;
  //TRGSEL = 0;
  //TRGEN = 0;

  adc_enable_tag(ADC); // ADC->ADC_EMR |= (1<<24);    // turn on channel number tags
  adc_enable_channel(ADC, ADC_CHANNEL_0); // Iq2
  adc_enable_channel(ADC, ADC_CHANNEL_1); // Iq1
  adc_enable_channel(ADC, ADC_CHANNEL_2); // Ux5
  adc_enable_channel(ADC, ADC_CHANNEL_3); // Ux4
  adc_enable_channel(ADC, ADC_CHANNEL_4); // Ub
  adc_enable_channel(ADC, ADC_CHANNEL_5); // Ua
  adc_enable_channel(ADC, ADC_CHANNEL_6); // Ud
  adc_enable_channel(ADC, ADC_CHANNEL_7); // Iv
//  adc_enable_anch(ADC); // Enable separate
//  adc_enable_channel_differential_input(ADC, ADC_CHANNEL_4);
//  adc_enable_channel_differential_input(ADC, ADC_CHANNEL_5);
//  ADC->ADC_SEQR1=0x01234567;  // use A0 to A7 in order into array 
  if (*pwm_event) {
      adc_configure_trigger(ADC, ADC_TRIG_PWM_EVENT_LINE_0, 0); 
  } else {
      adc_configure_trigger(ADC, ADC_TRIG_SW, 0); 
  }
  ADC->ADC_SEQR1=0x01234567;  // use A0 to A7 in order into array 
  adc_start_sequencer(ADC); //  ADC->ADC_MR |=0x80000000;   //USEQ bit set, saying use the sequence
  NVIC_EnableIRQ(ADC_IRQn); // interrupt controller set to enable adc.
  adc_enable_interrupt(ADC, ADC_IER_ENDRX);
  // following are the DMA controller registers for this peripheral
  // "receive buffer address" 
  // pdc_read_rx_ptr(ADC) = (uint32_t) ADCbuffer; 
  ADC->ADC_RPR = (uint32_t) ADCbuffer;   // DMA receive pointer register  points to beginning of global_ADCount
  // "receive count" 
  // pdc_read_rx_counter(ADC) = 8; 
  ADC->ADC_RCR = 8;  //  receive counter set to 12
  // "next-buffer address"
  // pdc_read_rx_next_ptr(ADC) = (uint32_t) ADCbuffer; 
  ADC->ADC_RNPR = (uint32_t) ADCbuffer; // next receive pointer register DMA global_ADCounts_Arrayfer  points to second set of data 
  // and "next count"
  // pdc_read_rx_next_counter(ADC) = 5; 
  ADC->ADC_RNCR = 8;   //  and next counter is set to 12
  // "transmit control register"
  ADC->ADC_PTCR = 1;  // transfer control register for the DMA is set to enable receiver channel requests
  // now that all things are set up, it is safe to start the ADC.....
  // ADC->ADC_MR |=0x80; // mode register of adc bit seven, free run, set to free running. starts ADC
  if (!*pwm_event) {
     adc_start(ADC); // ADC->ADC_CR = 2; // Start ADC conversion
  }
}

// ADC interrupt service routine
void Adc_Seqr_ADCHandler(){     // for the ATOD: re-initialize DMA pointers and count
  
  unsigned long f=ADC->ADC_ISR;  //   read the interrupt status register 
  if (f & (1<<27)){ /// check the bit "endrx"  in the status register
  /// set up the "next pointer register" 
  // ADC->ADC_CR  = 0x00;   //Stop conversion
  ADC->ADC_RNPR = (uint32_t) ADCbuffer;  // "receive next pointer" register set to global_ADCounts_Array 
  // set up the "next count"
  ADC->ADC_RNCR = 8;  // "receive next" counter set to 12
  }
}

  //interrupt handler
void ADC_Handler(){
    Adc_Seqr_ADCHandler();
}

//Read analogue input
inline void adc_read_seqr(double *ADC_in, bool *pwm_event, bool *ch4_Iinp)
{
//declare variables
  double Ioffset = 1861.4; // 2.5*0.6/3.3*4095; // 2.5 V  vdiv: 1k, 1k5
  double Iscale = 0.003358; //0.4*0.6/3.3*4095; // 0.4 V/A  vdiv: 1k, 1k5
 // double Iscale_Ix4 = 0.0179; //3*0.025*0.6/3.3*4095; // 3*0.025 V/A  vdiv: 1k, 1k5
  double Iscale_Ix4 = 0.004298; //3*0.10416*0.6/3.3*4095; // 3*0.10416 V/A  vdiv: 1k, 1k5
  double Uoffset = 0;
  double Uscale = 0.0144; // R1=1k5//10k=1.304k, R2=22k: 1.304/(1.304+22)=0.05597; ADC: 0.05597/3.3V*4095
  double Uscale_Ux5 = 0.0126; // R1=1k5, R2=22k: 1.50/(1.50+22)=0.06383; ADC: 0.06383/3.3V*4095
  double ch4_offset;
  double ch4_scale;
  
  if (ch4_Iinp) {
      ch4_offset = Ioffset;
      ch4_scale   = Iscale_Ix4;
  } else {
      ch4_offset = Uoffset;
      ch4_scale   = Uscale;
  }
  double ADC_offset[14] = {Ioffset,Ioffset,Uoffset,ch4_offset,Uoffset,Uoffset,Uoffset,Ioffset,0,0,0,0,0,0}; 
  double ADC_gain[14] = {Iscale,Iscale,Uscale_Ux5,ch4_scale,Uscale,Uscale,Uscale,Iscale,0,0,0,0,0,0};
  //  unsigned long start_time = micros();
  for (int i=0;i<8;i++){
      int tag = (ADCbuffer[i] & 0x0f000)>>12; 
      *(ADC_in+tag) = ADC_gain[tag]*((ADCbuffer[i] & 0x00fff)-ADC_offset[tag]);
  }
  if (!*pwm_event) {
      adc_start(ADC); // ADC->ADC_CR = 2; // Start ADC conversion
  }
}

//Read digital input
inline void pio_read_poll(bool *G)
{
  bool GaL   = !!(REG_PIOC_PDSR & (1<<6)); // Read Pwm2L  PC6
  bool GaH   = !!(REG_PIOC_PDSR & (1<<7)); // Read Pwm2H  PC7
  bool GbL   = !!(REG_PIOC_PDSR & (1<<8)); // Read Pwm3L  PC8
  bool GbH   = !!(REG_PIOC_PDSR & (1<<9)); // Read Pwm3H  PC9
  *(G+0) = GaL;
  *(G+1) = GaH;
  *(G+2) = GbL;
  *(G+3) = GbH;
}

